#!/usr/bin/python

import sys
import subprocess
import re
import time

def getUsers():
    proc = subprocess.check_output(["momctl", "-q", "users"])
    us = proc.split()[-1][:-1].split(',')
    return us

def getProcesses(activeu, on_off):
    pbs_mom = False
    i = 0
    proc = subprocess.Popen(["ps", "fax", "-eo" "user:20,stat,pid,command"], stdout=subprocess.PIPE)
    for line in proc.stdout.readlines():
        splitted = line.split()
        if re.search('D', splitted[1]) or re.search('Z', splitted[1]):
            ti = subprocess.Popen(["ps", "-o", "start", "-p", splitted[2]], stdout=subprocess.PIPE)
            for l in ti.stdout.readlines():
                continue
            if splitted[0] == "root" or splitted[0] not in activeu:
                if re.search('\_ sync', line) and splitted[0] == "root" or re.search('[java]', line):
                    if on_off == "on":
                        print("Found sync under root or java defunct from " + l + ", running iptables \n" + line)
                        subprocess.call(["iptables", "-I", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        time.sleep(600)
                        subprocess.call(["iptables", "-D", "OUTPUT", "-p", "tcp", "--dport", "2049", "-j", "REJECT"])
                        break
        i += 1


if __name__ == "__main__":
    iptables_on_off = sys.argv[1]
    users = getUsers()
    getProcesses(users, iptables_on_off)
